## eccodes 2.35.0

=== debian/changelog ===
eccodes (2.35.0-1deepin1) unstable; urgency=medium

  * Do not unpack orig-data.tar.xz in d/rules since we already have them in
    data/

 -- Tianyu Chen <sweetyfish@deepin.org>  Thu, 06 Jun 2024 13:02:57 +0800

eccodes (2.35.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Apr 2024 08:01:26 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR=/usr/include/$(DEB_HOST_MULTIARCH)
DESTDIR=$(CURDIR)/debian/tmp
CMAKEDIR:=$(DESTDIR)/$(LIBDIR)/cmake/eccodes

BUILDDIR:=$(CURDIR)/debian/build
BUILDDIR_DEFAULT:=$(BUILDDIR)-$(FC_DEFAULT)

# For hardening
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) #  -fPIC
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)



export LDFLAGS CFLAGS CPPFLAGS CXXFLAGS

DO_TEST:=true

# Pull in ecbuild macros rather than local ones
BUILD_FLAGS =  \
	-DENABLE_INSTALL_ECCODES_DEFINITIONS=ON \
	-DENABLE_INSTALL_ECCODES_SAMPLES=ON \
	-DENABLE_PNG=ON \
	-DENABLE_AEC=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_RELATIVE_RPATHS=OFF \
	-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}" \
	-DENABLE_ALIGN_MEMORY=ON \
	-DENABLE_GRIB_TIMER=ON \
	-DENABLE_ECCODES_OMP_THREADS=On  \

%:
	FC=$(FC_DEFAULT) dh $@ --buildsystem=ecbuild --builddirectory=${BUILDDIR_DEFAULT} \
		--no-parallel --with fortran_mod

override_dh_auto_configure:
	dh_auto_configure -- \
	    ${BUILD_FLAGS} 
	# ( cd ${BUILDDIR_DEFAULT}/data ; tar axpf $(CURDIR)/../eccodes_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_install:
	cd $(BUILDDIR_DEFAULT) && $(MAKE) install DESTDIR=$(DESTDIR)  
	# Move to multiarch dir
	mkdir -p  $(DESTDIR)/$(INCDIR)
	mv $(DESTDIR)/usr/include/*.h $(DESTDIR)/$(INCDIR)
	for d in libeccodes_f90.so	libeccodes.so ; do \
		chrpath -d $(DESTDIR)/$(LIBDIR)/$$d.0 ; done
	chrpath -d $(DESTDIR)/usr/bin/grib_to_netcdf
	dh_install
	# Setup cmake files for magics++, metview, etc.
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' 	$(CMAKEDIR)/eccodes-targets.cmake
	sed -i -e 's%/usr/lib/libeccodes%${LIBDIR}/libeccodes%' 			$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}%/usr%'                  			$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%${LIBDIR}/libopenjpeg.so;%%' 					$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%;${LIBDIR}/libpng.so%%g' 						$(CMAKEDIR)/eccodes-targets-release.cmake
	sed -i -e 's%;${LIBDIR}/libopenjpeg.so%%g' 					$(CMAKEDIR)/eccodes-config.cmake
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake/eccodes%${LIBDIR}/cmake/eccodes%g' $(CMAKEDIR)/eccodes-config.cmake
	sed -i -e 's%;${LIBDIR}/libpng.so%%g' 						$(CMAKEDIR)/eccodes-config.cmake
	# For bit-reproducibility, sanitize the build paths
	for f in eccodes-config.cmake eccodes-import.cmake ; do \
		sed -i -e 's%${CURDIR}%/build/eccodes%g' $(CMAKEDIR)/$$f ; \
		sed -i -e 's%$${eccodes_BASE_DIR}/share%/usr/share%g' $(CMAKEDIR)/$$f ; \
		done
	# file exists on full builds only
	[ - e debian/libeccodes-dev/$(INCDIR)/eccodes_ecbuild_config.h ] && ( \
		sed -i -e 's%${CURDIR}%/build/eccodes%g'  debian/libeccodes-dev/$(INCDIR)/eccodes_ecbuild_config.h \
		) || true	

override_dh_auto_clean:
	dh_auto_clean
	# Things that upstream leaves behind
	rm -f configure.ac configure configure.in
	rm -f tests/bitmap.rules tests/out.grib1 tests/out.grib2 tests/out.gribidx \
	      tests/rules tests/simple_ieee_test.grib1.txt tests/statistics.filter \
	      tests/statistics.out tests/x.grib \
	      data/change_scanning_rotated_ll.filter examples/F90/index.idx

override_dh_fixperms:
	dh_fixperms
	test -e /usr/bin/dh_buildinfo && dh_buildinfo
	-chmod -x debian/libeccodes-dev/usr/share/doc/libeccodes-dev/examples/F90/include.sh
	-chmod +x debian/libeccodes-data/usr/share/eccodes/definitions/installDefinitions.sh

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=${BUILDDIR_DEFAULT}/lib dh_auto_test  ) || true
	# for f in $(FC_OPTIONAL) ; do \
	#  ( $(DO_TEST) && ( LD_LIBRARY_PATH=${BUILDDIR}-$$f/lib dh_auto_test  ) || true ) ; done

## eccodes 2.36.0

=== debian/changelog ===
eccodes (2.36.0-1) unstable; urgency=medium

  * New upstream release
  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * Disable threading; currently fails to build with threading

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Jul 2024 08:23:24 +0100

## eccodes 2.36.1

=== src/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
list( APPEND eccodes_src_files
    accessor/grib_accessor.cc
    accessor/grib_accessors_list.cc
    grib_accessor_class.cc
    shared_functions.cc
    step_unit.cc
    step.cc
    step_utilities.cc
    grib_api.h
    grib_timer.cc
    eccodes.h
    action.cc
    action_class_alias.cc
    action_class_gen.cc
    action_class_if.cc
    action_class_switch.cc
    accessor/grib_accessor_class_g1fcperiod.cc
    accessor/grib_accessor_class_g1end_of_interval_monthly.cc
    accessor/grib_accessor_class_mars_param.cc
    action_class_section.cc
    action_class_list.cc
    action_class_while.cc
    action_class_put.cc
    action_class_meta.cc
    action_class_remove.cc
    action_class_rename.cc
    action_class_assert.cc
    action_class_template.cc
    action_class_trigger.cc
    action_class_when.cc
    action_class_concept.cc
    action_class_hash_array.cc
    action_class_set.cc
    action_class_set_sarray.cc
    action_class_set_darray.cc
    action_class_noop.cc
    action_class_write.cc
    action_class_print.cc
    action_class_close.cc
    action_class_variable.cc
    action_class_modify.cc
    action_class_transient_darray.cc
    eccodes.cc
    grib_concept.cc
    grib_hash_array.cc
    grib_bufr_descriptor.cc
    grib_bufr_descriptors_array.cc
    grib_darray.cc
    grib_sarray.cc
    grib_oarray.cc
    grib_vdarray.cc
    grib_vsarray.cc
    grib_iarray.cc
    grib_viarray.cc
    codes_memfs.cc
    accessor/grib_accessor_class_gen.cc
    accessor/grib_accessor_class_ascii.cc
    accessor/grib_accessor_class_bit.cc
    accessor/grib_accessor_class_bitmap.cc
    accessor/grib_accessor_class_bits.cc
    accessor/grib_accessor_class_bits_per_value.cc
    accessor/grib_accessor_class_bufr_elements_table.cc
    accessor/grib_accessor_class_bufr_data_array.cc
    accessor/grib_accessor_class_bufr_data_element.cc
    accessor/grib_accessor_class_bufr_group.cc
    accessor/grib_accessor_class_bufr_string_values.cc
    accessor/grib_accessor_class_pack_bufr_values.cc
    accessor/grib_accessor_class_unpack_bufr_values.cc
    accessor/grib_accessor_class_group.cc
    accessor/grib_accessor_class_non_alpha.cc
    accessor/grib_accessor_class_g1bitmap.cc
    accessor/grib_accessor_class_g2bitmap.cc
    accessor/grib_accessor_class_concept.cc
    accessor/grib_accessor_class_hash_array.cc
    accessor/grib_accessor_class_decimal_precision.cc
    accessor/grib_accessor_class_divdouble.cc
    accessor/grib_accessor_class_multdouble.cc
    accessor/grib_accessor_class_budgdate.cc
    accessor/grib_accessor_class_validity_date.cc
    accessor/grib_accessor_class_validity_time.cc
    accessor/grib_accessor_class_bytes.cc
    accessor/grib_accessor_class_change_alternative_row_scanning.cc
    accessor/grib_accessor_class_change_scanning_direction.cc
    accessor/grib_accessor_class_check_internal_version.cc
    accessor/grib_accessor_class_codeflag.cc
    accessor/grib_accessor_class_smart_table.cc
    accessor/grib_accessor_class_smart_table_column.cc
    accessor/grib_accessor_class_codetable.cc
    accessor/grib_accessor_class_codetable_units.cc
    accessor/grib_accessor_class_codetable_title.cc
    accessor/grib_accessor_class_step_human_readable.cc
    accessor/grib_accessor_class_count_file.cc
    accessor/grib_accessor_class_count_total.cc
    accessor/grib_accessor_class_double.cc
    accessor/grib_accessor_class_element.cc
    accessor/grib_accessor_class_evaluate.cc
    accessor/grib_accessor_class_g1date.cc
    accessor/grib_accessor_class_g1monthlydate.cc
    accessor/grib_accessor_class_library_version.cc
    accessor/grib_accessor_class_when.cc
    accessor/grib_accessor_class_g1verificationdate.cc
    accessor/grib_accessor_class_g1day_of_the_year_date.cc
    accessor/grib_accessor_class_g1_half_byte_codeflag.cc
    accessor/grib_accessor_class_g1forecastmonth.cc
    accessor/grib_accessor_class_g1step_range.cc
    accessor/grib_accessor_class_g2step_range.cc
    accessor/grib_accessor_class_data_g22order_packing.cc
    accessor/grib_accessor_class_mars_step.cc
    accessor/grib_accessor_class_message_copy.cc
    accessor/grib_accessor_class_dictionary.cc
    accessor/grib_accessor_class_latlon_increment.cc
    accessor/grib_accessor_class_g2date.cc
    accessor/grib_accessor_class_g2level.cc
    accessor/grib_accessor_class_g2end_step.cc
    accessor/grib_accessor_class_g2latlon.cc
    accessor/grib_accessor_class_g2lon.cc
    accessor/grib_accessor_class_global_gaussian.cc
    accessor/grib_accessor_class_gaussian_grid_name.cc
    accessor/grib_accessor_class_getenv.cc
    accessor/grib_accessor_class_gts_header.cc
    accessor/grib_accessor_class_ifs_param.cc
    accessor/grib_accessor_class_julian_day.cc
    accessor/grib_accessor_class_julian_date.cc
    accessor/grib_accessor_class_closest_date.cc
    accessor/grib_accessor_class_latlonvalues.cc
    accessor/grib_accessor_class_latitudes.cc
    accessor/grib_accessor_class_longitudes.cc
    accessor/grib_accessor_class_offset_file.cc
    accessor/grib_accessor_class_scale.cc
    accessor/grib_accessor_class_from_scale_factor_scaled_value.cc
    accessor/grib_accessor_class_g2bitmap_present.cc
    accessor/grib_accessor_class_ibmfloat.cc
    accessor/grib_accessor_class_ieeefloat.cc
    accessor/grib_accessor_class_constant.cc
    accessor/grib_accessor_class_iterator.cc
    accessor/grib_accessor_class_message.cc
    accessor/grib_accessor_class_nearest.cc
    accessor/grib_accessor_class_ksec1expver.cc
    accessor/grib_accessor_class_label.cc
    accessor/grib_accessor_class_long.cc
    accessor/grib_accessor_class_lookup.cc
    accessor/grib_accessor_class_octahedral_gaussian.cc
    accessor/grib_accessor_class_octet_number.cc
    accessor/grib_accessor_class_headers_only.cc
    accessor/grib_accessor_class_padding.cc
    accessor/grib_accessor_class_pad.cc
    accessor/grib_accessor_class_padto.cc
    accessor/grib_accessor_class_padtoeven.cc
    accessor/grib_accessor_class_padtomultiple.cc
    accessor/grib_accessor_class_section_padding.cc
    accessor/grib_accessor_class_packing_type.cc
    accessor/grib_accessor_class_section_pointer.cc
    accessor/grib_accessor_class_position.cc
    accessor/grib_accessor_class_signed.cc
    accessor/grib_accessor_class_signed_bits.cc
    accessor/grib_accessor_class_section.cc
    accessor/grib_accessor_class_step_in_units.cc
    accessor/grib_accessor_class_optimal_step_units.cc
    accessor/grib_accessor_class_section_length.cc
    accessor/grib_accessor_class_g1_message_length.cc
    accessor/grib_accessor_class_g1_section4_length.cc
    accessor/grib_accessor_class_size.cc
    accessor/grib_accessor_class_rdbtime_guess_date.cc
    accessor/grib_accessor_class_scale_values.cc
    accessor/grib_accessor_class_offset_values.cc
    accessor/grib_accessor_class_sprintf.cc
    accessor/grib_accessor_class_round.cc
    accessor/grib_accessor_class_spectral_truncation.cc
    accessor/grib_accessor_class_time.cc
    accessor/grib_accessor_class_transient.cc
    accessor/grib_accessor_class_trim.cc
    accessor/grib_accessor_class_transient_darray.cc
    accessor/grib_accessor_class_values.cc
    accessor/grib_accessor_class_simple_packing_error.cc
    accessor/grib_accessor_class_data_simple_packing.cc
    accessor/grib_accessor_class_count_missing.cc
    accessor/grib_accessor_class_data_sh_packed.cc
    accessor/grib_accessor_class_data_sh_unpacked.cc
    accessor/grib_accessor_class_number_of_values_data_raw_packing.cc
    accessor/grib_accessor_class_data_g1simple_packing.cc
    accessor/grib_accessor_class_data_g1shsimple_packing.cc
    accessor/grib_accessor_class_data_shsimple_packing.cc
    accessor/grib_accessor_class_data_dummy_field.cc
    accessor/grib_accessor_class_variable.cc
    accessor/grib_accessor_class_second_order_bits_per_value.cc
    accessor/grib_accessor_class_data_g2simple_packing.cc
    accessor/grib_accessor_class_data_g2simple_packing_with_preprocessing.cc
    accessor/grib_accessor_class_data_g2shsimple_packing.cc
    accessor/grib_accessor_class_data_g2complex_packing.cc
    accessor/grib_accessor_class_data_g1second_order_row_by_row_packing.cc
    accessor/grib_accessor_class_data_g1second_order_constant_width_packing.cc
    accessor/grib_accessor_class_data_g1second_order_general_packing.cc
    accessor/grib_accessor_class_data_g1second_order_general_extended_packing.cc
    accessor/grib_accessor_class_g2grid.cc
    accessor/grib_accessor_class_unexpanded_descriptors.cc
    accessor/grib_accessor_class_expanded_descriptors.cc
    accessor/grib_accessor_class_bufrdc_expanded_descriptors.cc
    accessor/grib_accessor_class_data_apply_bitmap.cc
    accessor/grib_accessor_class_data_apply_boustrophedonic.cc
    accessor/grib_accessor_class_data_apply_boustrophedonic_bitmap.cc
    accessor/grib_accessor_class_data_secondary_bitmap.cc
    accessor/grib_accessor_class_data_g1secondary_bitmap.cc
    accessor/grib_accessor_class_data_g2secondary_bitmap.cc
    accessor/grib_accessor_class_data_jpeg2000_packing.cc
    accessor/grib_accessor_class_data_png_packing.cc
    accessor/grib_accessor_class_data_ccsds_packing.cc
    accessor/grib_accessor_class_data_raw_packing.cc
    accessor/grib_accessor_class_data_complex_packing.cc
    accessor/grib_accessor_class_data_g1complex_packing.cc
    accessor/grib_accessor_class_gds_not_present_bitmap.cc
    accessor/grib_accessor_class_gds_is_present.cc
    accessor/grib_accessor_class_select_step_template.cc
    accessor/grib_accessor_class_local_definition.cc
    accessor/grib_accessor_class_g2_eps.cc
    accessor/grib_accessor_class_g2_aerosol.cc
    accessor/grib_accessor_class_g2_chemical.cc
    accessor/grib_accessor_class_g2_mars_labeling.cc
    accessor/grib_accessor_class_md5.cc
    accessor/grib_accessor_class_proj_string.cc
    grib_jasper_encoding.cc
    grib_openjpeg_encoding.cc
    action_class_set_missing.cc
    accessor/grib_accessor_class_number_of_points.cc
    accessor/grib_accessor_class_suppressed.cc
    grib_index.cc
    accessor/grib_accessor_class_number_of_points_gaussian.cc
    accessor/grib_accessor_class_number_of_values.cc
    accessor/grib_accessor_class_number_of_coded_values.cc
    accessor/grib_accessor_class_g1number_of_coded_values_sh_complex.cc
    accessor/grib_accessor_class_g1number_of_coded_values_sh_simple.cc
    accessor/grib_accessor_class_dirty.cc
    accessor/grib_accessor_class_statistics.cc
    accessor/grib_accessor_class_statistics_spectral.cc
    accessor/grib_accessor_class_unsigned.cc
    accessor/grib_accessor_class_unsigned_bits.cc
    accessor/grib_accessor_class_raw.cc
    accessor/grib_accessor_class_bufr_simple_thinning.cc
    accessor/grib_accessor_class_bufr_extract_subsets.cc
    accessor/grib_accessor_class_bufr_extract_area_subsets.cc
    accessor/grib_accessor_class_bufr_extract_datetime_subsets.cc
    accessor/grib_accessor_class_spd.cc
    accessor/grib_accessor_class_sum.cc
    accessor/grib_accessor_class_to_integer.cc
    accessor/grib_accessor_class_to_double.cc
    accessor/grib_accessor_class_to_string.cc
    accessor/grib_accessor_class_sexagesimal2decimal.cc
    accessor/grib_accessor_class_vector.cc
    accessor/grib_accessor_class_long_vector.cc
    grib_gaussian_reduced.cc
    accessor/grib_accessor_class_abstract_vector.cc
    accessor/grib_accessor_class_abstract_long_vector.cc
    grib_loader_from_handle.cc
    grib_bits.cc
    grib_ibmfloat.cc
    grib_ieeefloat.cc
    accessor/grib_accessor_class_reference_value_error.cc
    grib_memory.cc
    grib_buffer.cc
    grib_dumper.cc
    grib_dumper_class_serialize.cc
    grib_dumper_class_debug.cc

=== debian/changelog ===
eccodes (2.36.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Jul 2024 09:00:15 +0100

=== debian/control ===
Source: eccodes
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-buildinfo, 
  dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.7.0),
  libjpeg-dev, 
  libpng-dev, 
  flex, 
  bison, 
  quilt,
  swig, 
  doxygen,
  libboost-dev, 
  libhdf5-dev, 
  chrpath,
  libaec-dev,
  libnetcdf-dev,
  libopenjp2-7-dev
Build-Conflicts: libopenjpeg-dev, libeccodes-dev
Standards-Version: 4.7.0
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org/science-team/eccodes.git
Vcs-Git: https://salsa.debian.org/science-team/eccodes.git -b debian/latest

Package: libeccodes0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeccodes-data
Description: GRIB and BUFR enecoding/encoding software library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 It is a replacement for the grib-api and emoslib libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GRIB and BUFR enecoding/encoding software library - data
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 
Package: libeccodes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeccodes0 (= ${binary:Version}), 
  ${misc:Depends}, ${shlibs:Depends},  ${fortran:Depends},
  libaec-dev, libpng-dev, libjpeg-dev, zlib1g-dev
Description: GRIB and BUFR decoding/encoding software library (development)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libeccodes-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mksh | pdksh | zsh | ksh
Description: GRIB decoding/encoding software (utilities)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: GRIB decoding/encoding software (documentation)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This provides the documentation for the library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}" \
 	-DENABLE_ALIGN_MEMORY=ON \
 	-DENABLE_GRIB_TIMER=ON \
-	-DENABLE_ECCODES_OMP_THREADS=On  \
+	-DENABLE_ECCODES_OMP_THREADS=Off  \
 
 %:
 	FC=$(FC_DEFAULT) dh $@ --buildsystem=ecbuild --builddirectory=${BUILDDIR_DEFAULT} \
@@ -46,7 +46,7 @@
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	    ${BUILD_FLAGS} 
-	# ( cd ${BUILDDIR_DEFAULT}/data ; tar axpf $(CURDIR)/../eccodes_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
+	( cd ${BUILDDIR_DEFAULT}/data ; tar axpf $(CURDIR)/../eccodes_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
 
 override_dh_install:
 	cd $(BUILDDIR_DEFAULT) && $(MAKE) install DESTDIR=$(DESTDIR)

## eccodes 2.38.3

=== CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
###############################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
if(NOT ecbuild_FOUND)
    message(STATUS "Fetching ecbuild...")
    include(FetchContent)
    FetchContent_Populate(ecbuild
        GIT_REPOSITORY https://github.com/ecmwf/ecbuild.git
        GIT_TAG        3.8.5
    )
    find_package( ecbuild 3.7 REQUIRED HINTS ${ecbuild_SOURCE_DIR})
endif()

# Initialise project
project( eccodes LANGUAGES CXX )
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


###############################################################################
# system checks needed for eccodes_config.h and some options like MEMFS

check_type_size( int     ECCODES_SIZEOF_INT )
check_type_size( long    ECCODES_SIZEOF_LONG )
check_type_size( size_t  ECCODES_SIZEOF_SIZE_T )

check_include_files( assert.h      ECCODES_HAVE_ASSERT_H )
check_include_files( string.h      ECCODES_HAVE_STRING_H )
check_include_files( sys/types.h   ECCODES_HAVE_SYS_TYPES_H )
check_include_files( sys/stat.h    ECCODES_HAVE_SYS_STAT_H )
check_include_files( fcntl.h       ECCODES_HAVE_FCNTL_H )
check_include_files( unistd.h      ECCODES_HAVE_UNISTD_H )

check_symbol_exists( fseeko          "stdio.h"    ECCODES_HAVE_FSEEKO )
check_symbol_exists( posix_memalign  "stdlib.h"   ECCODES_HAVE_POSIX_MEMALIGN )
check_symbol_exists( fmemopen        "stdio.h"    ECCODES_HAVE_FMEMOPEN )
check_symbol_exists( funopen         "stdio.h"    ECCODES_HAVE_FUNOPEN )
check_symbol_exists( realpath        "stdlib.h"   ECCODES_HAVE_REALPATH )
check_symbol_exists( fsync           "unistd.h"   ECCODES_HAVE_FSYNC)
check_symbol_exists( fdatasync       "unistd.h"   ECCODES_HAVE_FDATASYNC)

check_c_source_compiles(
      " typedef int foo_t;
      static inline foo_t static_foo(void){return 0;}
      foo_t foo(void){return 0;}
      int main(int argc, char *argv[]){ return static_foo(); }
      " ECCODES_HAVE_C_INLINE
)

include(eccodes_test_endiness)
if( EC_OS_NAME MATCHES "windows" )
    include(eccodes_find_linux_utils)
endif()

ecbuild_debug("ECCODES_BIG_ENDIAN=${ECCODES_BIG_ENDIAN}")
ecbuild_debug("ECCODES_LITTLE_ENDIAN=${ECCODES_LITTLE_ENDIAN}")
ecbuild_info("Operating system=${CMAKE_SYSTEM} (${EC_OS_BITS} bits)")

# Only support 64 bit operating systems
if( NOT EC_OS_BITS EQUAL "64" )
    ecbuild_critical( "Operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) -- ecCodes only supports 64 bit platforms" )
endif()

###############################################################################
# some variables/options of this project

# ecbuild_add_cxx_flags("-Wno-write-strings" NO_FAIL)
# ecbuild_add_cxx_flags("-Wno-writable-strings" NO_FAIL)
# ecbuild_add_cxx_flags("-Wno-deprecated" NO_FAIL)

if( CMAKE_CXX_COMPILER_ID STREQUAL "Cray" )
    set(CMAKE_CXX_FLAGS "-hstd=c++11 ${CMAKE_CXX_FLAGS}")
endif()

ecbuild_add_option( FEATURE PRODUCT_GRIB
    DESCRIPTION "Support for the product GRIB"
    DEFAULT ON )
ecbuild_add_option( FEATURE PRODUCT_BUFR
    DESCRIPTION "Support for the product BUFR"
    DEFAULT ON )
if( NOT HAVE_PRODUCT_GRIB AND NOT HAVE_PRODUCT_BUFR )
    ecbuild_critical("Cannot disable both GRIB and BUFR! Please specify just one option")
endif()

ecbuild_add_option( FEATURE EXAMPLES
    DESCRIPTION "Build the examples"
    DEFAULT ON )

ecbuild_add_option( FEATURE BUILD_TOOLS
    DESCRIPTION "Build the command line tools"
    DEFAULT ON )

ecbuild_add_option( FEATURE GEOGRAPHY
    DESCRIPTION "Support for Geoiterator and nearest neighbour"
    DEFAULT ON )

ecbuild_add_option( FEATURE JPG
    DESCRIPTION "Support for JPG decoding/encoding"
    DEFAULT ON )
# Options related to JPG. The JasPer and OpenJPEG libraries
ecbuild_add_option( FEATURE JPG_LIBJASPER
    DESCRIPTION "Support for JPG decoding/encoding with the JasPer library"
    CONDITION ENABLE_JPG
    DEFAULT ON )
ecbuild_add_option( FEATURE JPG_LIBOPENJPEG
    DESCRIPTION "Support for JPG decoding/encoding with the OpenJPEG library"
    CONDITION ENABLE_JPG
    DEFAULT ON )

ecbuild_add_option( FEATURE PNG
    DESCRIPTION "Support for PNG decoding/encoding"
    DEFAULT OFF
    REQUIRED_PACKAGES PNG )

if( HAVE_PNG )
    set( HAVE_LIBPNG 1 ) # compatibility with autotools
    add_definitions( ${PNG_DEFINITIONS} )
else()
    set( HAVE_LIBPNG 0 )
endif()

ecbuild_add_option( FEATURE NETCDF
    DESCRIPTION "Support for GRIB to NetCDF conversion"
    DEFAULT ON
    REQUIRED_PACKAGES NetCDF
    NO_TPL )

find_package( AEC )
if(NOT DEFINED ENABLE_AEC AND NOT AEC_FOUND)
  ecbuild_critical("AEC library was not found.\n"
                   "AEC (Adaptive Entropy Coding) provides the WMO GRIB CCSDS compression and decompression of data. "
                   "This is highly recommended from ecCodes >= 2.25.0"
                   "\nTo force the build without it, use -DENABLE_AEC=OFF")
endif()
ecbuild_add_option( FEATURE AEC
    DESCRIPTION "Support for Adaptive Entropy Coding"
    DEFAULT ON
    CONDITION AEC_FOUND )

ecbuild_find_python( VERSION 3.6 NO_LIBS )
# find_package( NumPy )

## TODO REQUIRED_LANGUAGES Fortran
ecbuild_add_option( FEATURE FORTRAN
    DESCRIPTION "Build the ecCodes Fortran interface"
    DEFAULT ON )

# TODO Remove this after REQUIRED_LANGUAGES
if( ENABLE_FORTRAN )
    # will set EC_HAVE_FORTRAN with the result
    set( EC_HAVE_FORTRAN 0 )
    ecbuild_enable_fortran( MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/fortran/modules )
    set( HAVE_FORTRAN ${EC_HAVE_FORTRAN} )
else()
    set( HAVE_FORTRAN 0 )
endif()

# memfs requires only Python executable and not its libraries
ecbuild_add_option( FEATURE MEMFS
    DESCRIPTION "Memory based access to definitions/samples"
    DEFAULT OFF
    REQUIRED_PACKAGES Python3 )

#if( HAVE_MEMFS AND "${CMAKE_C_COMPILER_ID}" STREQUAL "Cray")
#  set( HAVE_MEMFS OFF )
#  ecbuild_warn("MEMFS not supported with Cray C compiler")
#endif()

if(HAVE_MEMFS)
  set( _will_install_defs_samples OFF )
else()
  set( _will_install_defs_samples ON )
endif()


# controls installation of files in definitions/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install definitions
ecbuild_add_option( FEATURE INSTALL_ECCODES_DEFINITIONS
    DESCRIPTION "Install the ecCodes definitions"
    DEFAULT ${_will_install_defs_samples} )

# controls installation of files in samples/ and ifs_samples/ -- note that it still creates the symlinks in the build dir
# by default, if memfs is available, then we don't need to install samples
ecbuild_add_option( FEATURE INSTALL_ECCODES_SAMPLES
    DESCRIPTION "Install the ecCodes samples, including IFS samples"
    DEFAULT ${_will_install_defs_samples} )

# advanced options (not visible in cmake-gui )

ecbuild_add_option( FEATURE MEMORY_MANAGEMENT   DESCRIPTION "Enable memory management" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ALIGN_MEMORY        DESCRIPTION "Enable memory alignment"  DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE TIMER               DESCRIPTION "Enable timer" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_THREADS     DESCRIPTION "Enable thread-safety using POSIX threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE ECCODES_OMP_THREADS DESCRIPTION "Enable thread-safety using OpenMP threads" DEFAULT OFF ADVANCED )
ecbuild_add_option( FEATURE EXTRA_TESTS         DESCRIPTION "Enable extended regression testing" DEFAULT OFF ADVANCED )

###############################################################################
# macro processing

set( ECCODES_EXTRA_LIBRARIES    "" )
set( ECCODES_EXTRA_INCLUDE_DIRS "" )
set( ECCODES_EXTRA_DEFINITIONS  "" )

find_package( CMath )
list( APPEND ECCODES_TPLS CMath )

### JPG support

set( HAVE_JPEG 0 )
set( HAVE_LIBJASPER 0 )
set( HAVE_LIBOPENJPEG 0 )

if( ENABLE_JPG )
    # Note: The function ecbuild_add_extra_search_paths is deprecated but we need it to find JasPer at ECMWF.
    #       It modifies CMAKE_PREFIX_PATH
    #       which can affect future package discovery if not undone by the caller.
    #       The current CMAKE_PREFIX_PATH is backed up as _CMAKE_PREFIX_PATH
    #
    #set(CMAKE_WARN_DEPRECATED OFF) # Suppress deprecation message
    #ecbuild_add_extra_search_paths( jasper )
    find_package( Jasper )
    #set(CMAKE_PREFIX_PATH ${_CMAKE_PREFIX_PATH})    # Restore CMAKE_PREFIX_PATH
    #set(CMAKE_WARN_DEPRECATED ON)  # Remove suppression

    find_package( OpenJPEG )

    if( JASPER_FOUND AND ENABLE_JPG_LIBJASPER )
        list( APPEND ECCODES_TPLS Jasper )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBJASPER 1 )
        # Extract JasPer's major version number to enable conditional code. See ECC-396
        string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+.*" "\\1" JASPER_VERSION_MAJOR "${JASPER_VERSION_STRING}")
    endif()

    if( OPENJPEG_FOUND AND ENABLE_JPG_LIBOPENJPEG )
        list( APPEND ECCODES_TPLS OpenJPEG )
        set( HAVE_JPEG 1 )
        set( HAVE_LIBOPENJPEG 1 )
    endif()

    ecbuild_info(" HAVE_JPEG=${HAVE_JPEG}")
    ecbuild_info(" HAVE_LIBJASPER=${HAVE_LIBJASPER}")
    ecbuild_info(" HAVE_LIBOPENJPEG=${HAVE_LIBOPENJPEG}")

endif()


###############################################################################
# other options

if( HAVE_TIMER )
    set( ECCODES_TIMER 1 )
else()
    set( ECCODES_TIMER 0 )
endif()

set( IS_BIG_ENDIAN 0 )
if( ECCODES_BIG_ENDIAN )
    set( IS_BIG_ENDIAN 1 )
endif()

set( MANAGE_MEM 0 )
if( ENABLE_MEMORY_MANAGEMENT )
    set( MANAGE_MEM 1 )
endif()

set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

# debug
ecbuild_info(" CMAKE_THREAD_LIBS_INIT=${CMAKE_THREAD_LIBS_INIT}")
ecbuild_info(" CMAKE_USE_PTHREADS_INIT=${CMAKE_USE_PTHREADS_INIT}")
ecbuild_info(" HAVE_ECCODES_THREADS=${HAVE_ECCODES_THREADS}")


set( GRIB_PTHREADS 0 )
set( GRIB_OMP_THREADS 0 )
set( GRIB_LINUX_PTHREADS 0 )
#if( HAVE_ECCODES_THREADS AND CMAKE_THREAD_LIBS_INIT )
if( HAVE_ECCODES_THREADS )
    if( NOT ${CMAKE_USE_PTHREADS_INIT} )
        ecbuild_critical("Pthreads is not supported on your system: thread library found=[${CMAKE_THREAD_LIBS_INIT}]")
    endif()
    set( GRIB_PTHREADS 1 )
    set( ECCODES_PTHREADS_LIBRARIES Threads::Threads ) # ECC-1268
    if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
        set( GRIB_LINUX_PTHREADS 1 )
    endif()
elseif(HAVE_ECCODES_OMP_THREADS)
    ecbuild_enable_omp()
    set( GRIB_OMP_THREADS 1 )
endif()

# Cannot have both options
if( HAVE_ECCODES_THREADS AND HAVE_ECCODES_OMP_THREADS )
    ecbuild_critical("Cannot enable both POSIX threads and OpenMP! Please specify just one option")
endif()

ecbuild_info(" POSIX THREADS = ${GRIB_PTHREADS}")
ecbuild_info(" OpenMP THREADS= ${GRIB_OMP_THREADS}")

set( GRIB_MEM_ALIGN 0 )
if( ENABLE_ALIGN_MEMORY )
  set( GRIB_MEM_ALIGN 1 )
endif()

# fix for #if IEEE_LE or IEE_BE instead of #ifdef

if( IEEE_BE )
    set( IEEE_LE 0 )
endif()

if( IEEE_LE )
    set( IEEE_BE 0 )
endif()

set( ECCODES_ON_WINDOWS 0 )
if( EC_OS_NAME MATCHES "windows" )
    # Symbols need to be explicitly exported on Windows so we can link to dlls.
    set( CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE )
    set( ECCODES_ON_WINDOWS 1 )

    # Suppress compliler warnings - see ECC-850
    # Suppress warnings about using 'insecure' functions. Fixing this would require changes all over

=== tools/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

list( APPEND ecc_tools_sources
             grib_tools.cc
             grib_options.cc
             grib_tools.h )

if( EC_OS_NAME MATCHES "windows" )
  list( APPEND ecc_tools_sources wingetopt.cc )
endif()

# tools library
ecbuild_add_library( TARGET    ecc_tools
                     TYPE      STATIC
                     NOINSTALL
                     SOURCES   ${ecc_tools_sources}
                     PRIVATE_LIBS      eccodes )

# tools binaries
list( APPEND ecc_tools_binaries
             codes_info codes_count codes_split_file
             grib_histogram grib_filter grib_ls grib_dump
             grib2ppm grib_set grib_get grib_get_data grib_copy
             grib_compare codes_parser grib_index_build bufr_index_build
             bufr_ls bufr_dump bufr_set bufr_get
             bufr_copy bufr_compare
             gts_get gts_compare gts_copy gts_dump gts_filter gts_ls
             metar_dump metar_ls metar_compare metar_get metar_filter metar_copy )

list( APPEND ecc_tools_binaries_extra
             grib_repair
             grib_to_json
             codes_export_resource
             grib_check_gaussian_grid
             bufr_split_by_rdbSubtype )

# Install generic tools
foreach( tool ${ecc_tools_binaries} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.cc
                            LIBS       ecc_tools )
endforeach()

# Install extra tools
# User must run cmake with -DECCODES_INSTALL_EXTRA_TOOLS=ON
foreach( tool ${ecc_tools_binaries_extra} )
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.cc
                            CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                            LIBS       ecc_tools )
endforeach()


# grib_count/bufr_count etc. Same source code, different executable names
ecbuild_add_executable( TARGET     grib_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )
ecbuild_add_executable( TARGET     bufr_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )
ecbuild_add_executable( TARGET     gts_count
                        SOURCES    codes_count.cc
                        LIBS       ecc_tools )

# grib to netcdf is optional
ecbuild_add_executable( TARGET     grib_to_netcdf
                        SOURCES    grib_to_netcdf.cc
                        CONDITION  HAVE_NETCDF
                        LIBS       ecc_tools NetCDF::NetCDF_C )


ecbuild_add_executable( TARGET     grib_list_keys
                        SOURCES    list_keys.cc
                        CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                        LIBS       ecc_tools )

ecbuild_add_executable( TARGET     codes_bufr_filter
                        SOURCES    bufr_filter.cc
                        LIBS       ecc_tools )


if( ECCODES_INSTALL_EXTRA_TOOLS )
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS enabled")
else()
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS disabled")
endif()
########################################

configure_file( codes_config.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/codes_config @ONLY )
file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/codes_config
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install( FILES ${CMAKE_BINARY_DIR}/bin/codes_config
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# BUFR compare script
install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_compare_dir
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# bufr_filter script (See ECC-205)
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/tools/bufr_filter
    ${CMAKE_BINARY_DIR}/bin/ )

install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_filter
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== debian/changelog ===
eccodes (2.38.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 18 Oct 2024 18:33:34 +0100

eccodes (2.38.0-2) unstable; urgency=medium

  * Drop obsolete deps on ksh and variants. Closes: #1078095

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Oct 2024 17:22:26 +0100

eccodes (2.38.0-1) unstable; urgency=medium

  * New upstream release
  * Enable OpenMP threads

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 25 Sep 2024 07:42:54 +0100

eccodes (2.37.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Sep 2024 09:32:56 +0100

=== debian/control ===
--- 
+++ 
@@ -61,7 +61,7 @@
 Package: libeccodes-tools
 Section: utils
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, mksh | pdksh | zsh | ksh
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: GRIB decoding/encoding software (utilities)
  ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
  .

## eccodes 2.39.1

=== debian/changelog ===
eccodes (2.39.1-1) unstable; urgency=medium

  * libeccodes-dev recommends libeccodes-tools
  * New upstream release
  * Drop use of dh-buildinfo. Closes: #1089911

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 Dec 2024 08:37:17 +0000

eccodes (2.39.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 23 Nov 2024 06:38:13 +0000
